//***************************************************************************************
//
//***************************************************************************************
//*                                                                           
//*  Project:  state machine generated from UML model using oAW                   
//*                                                                                                                         
//*                                                                  V0.8 Mhz
//***************************************************************************************
//0.3 ** 04.02.09 ** Changed meta model structure: binding of transition event and signal 
//0.4 ** 04.02.09 ** Enhancement to multiple state machine generation 
//					 from one UML model file
//0.6 ** 16.02.09 ** Added GUI and reconstructed project to run as independent jar
//0.7 ** 27.02.09 ** Add vector signal output possibility , minor changes
//0.8 ** 06.03.09 ** 1)Refine design structure of VHDL output:Two separate process
//					 for combinatoric and registers. 2) Add transition activity  	
//***************************************************************************************

package GENMain;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.regex.Pattern;

import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JFileChooser;
import org.apache.tools.ant.DirectoryScanner;
import com.sun.xml.internal.fastinfoset.util.StringArray;


public class oawGUI {

	private JPanel buttonPanel; 
	private mainFrame mFrame;
	
	/**
	 * 
	 * @param name = Name of the main GUI-frame
	 * @return 
	 */
	public oawGUI(String name){
		
		this.mFrame = new mainFrame(name);
		
		buttonPanel = new JPanel(new GridLayout(1,5,10,10));
		JPanel outputPanel = new JPanel(new GridLayout(1,1,0,0));
		
		JTextArea outputTArea = new JTextArea();
		//set line wrap
		outputTArea.setLineWrap(true);
		outputTArea.setWrapStyleWord(true);
		
		//Next 4 lines to redirect System.out to the Textarea
		TextAreaOutputStream tp = new TextAreaOutputStream(outputTArea);
		PrintStream out = new PrintStream(tp);
		System.setOut(out);
		System.setErr(out);

		JScrollPane Pane = new JScrollPane(outputTArea);
		
		Pane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER); 
		outputPanel.add(Pane);
		
		buildButtons();
			
		Container content = mFrame.getContentPane();		//Get the "main drawing area"
		content.setLayout(new BorderLayout());

		content.add(buttonPanel, BorderLayout.NORTH);	//Panel at top of Frame	
		content.add(outputPanel, BorderLayout.CENTER);
		
		mFrame.setVisible(true);	//Enable the JFrame	and make it visible
	}
	
	/**
	 * Method to create the necessary buttons on the Mainframe
	 */
	public void buildButtons(){	
		
		@SuppressWarnings("unused")
		JFileChooser fileChooser = new JFileChooser(); 					// new file / folder dialog
		
		@SuppressWarnings("unused")
		JButton openFileBtn = new JButton("Open File"); 
		JButton outputDirBtn = new JButton("Target Directory");
		outputDirBtn.setEnabled(true);
		
		JButton startGeneratorBtn = new JButton("Start Generator");
//		startGeneratorBtn.setEnabled(false);
		startGeneratorBtn.setEnabled(true);
	
//		JButton startSimulationBtn = new JButton("Start Simulation");
//		startSimulationBtn.setEnabled(false);	
		
		JButton endBtn = new JButton("End");
//		ButtonOpenFileHandler bofh = new ButtonOpenFileHandler(startGeneratorBtn, fileChooser, mFrame);
//		openFileBtn.addActionListener(bofh);
		
//		ButtonOutputDirBtnHandler bodh = new ButtonOutputDirBtnHandler(startGeneratorBtn, startSimulationBtn, fileChooser, mFrame);
//		outputDirBtn.addActionListener(bodh);
		
//		startGeneratorBtn.addActionListener(new ButtonStartGeneratorHandler(bofh,bodh));	
		startGeneratorBtn.addActionListener(new ButtonStartGeneratorHandler());
//		startSimulationBtn.addActionListener(new ButtonStartSimulationHandler(bodh));
		endBtn.addActionListener(new ButtonEndHandler(mFrame));
		
//		buttonPanel.add(openFileBtn);
//		buttonPanel.add(outputDirBtn);
		buttonPanel.add(startGeneratorBtn);
		

		// check if path variable contains modelsim.exe search path e.g Path=C:\Modeltech_6.3d\win32\MODEL_TECH
/*		Map<String, String> map = System.getenv();
		if(map.get("Path").matches(".*Modeltech.*\\win32.*")){	 
		Boolean ModelsimFound = false;
			// check if Modelsim.exe is really available at the host system 
			for (int i = 0; i < map.get("Path").split(";").length; i++){
				if(map.get("Path").split(";")[i].matches(".*Modeltech.*\\win32.*")) // check all relevant path entries
				{
					File FileHandler= new File(map.get("Path").split(";")[i]+"\\modelsim.exe");
					if (FileHandler.exists()){ // check if modelsim.exe really exists
						System.out.println(">> Simulation enabled: Found modelsim.exe on your system!");	
						buttonPanel.add(startSimulationBtn);	// if ModelSim is available at the system add the simulation button
						ModelsimFound= true;
						break;
					}
				}
			}
			if(!ModelsimFound){
				System.out.println(">> Simulation disabled: Could not find modelsim.exe on your system!");	
			}
		}
		else{
			System.out.println("Modelsim directory not set in your system 'Path' variable -> Simulation disabled!");
			System.out.println(">> Path="+(map.get("Path")));
		}	*/
		buttonPanel.add(endBtn);
	}
}

	class mainFrame extends JFrame{
		
		private Boolean ModelFileSet;
		private Boolean OutputDirSet;

		private static final long serialVersionUID = 1L;
		mainFrame(String _name){
							
			super(_name);
			this.setSize(700, 300);	//size of the JFrame in Horizontal * Vertical Pixels
			
			ModelFileSet = false;
			OutputDirSet = false;
			
			setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//With this option, application will terminate when JFrame is closed
		}
		public void setModelFileSet(Boolean _ModelFileSet) {
			this.ModelFileSet = _ModelFileSet;
		}

		public Boolean getModelFileSet() {
			return this.ModelFileSet;
		}
		
		public void setOutputDirSet(Boolean _OutputDirSet) {
			this.OutputDirSet = _OutputDirSet;
		}

		public Boolean getOutputDirSet() {
			return this.OutputDirSet;
		}
	}

	
	/**
	 * Class required to redirect System.out to the specified JTextArea
	 */
	class TextAreaOutputStream extends OutputStream {
		JTextArea taN;
		
		TextAreaOutputStream(JTextArea _taN){
			this.taN = _taN;
		}
		
	    public void write(int b){
	        try{
	        	this.taN.append(String.valueOf((char) b));	
	        	this.taN.setCaretPosition(taN.getLineEndOffset(taN.getLineCount() - 1));	//Necessary to scroll automatically
	        } 
	        catch (Exception e) {
	        	e.printStackTrace();
	        }
	    }	    
	}
	
	class ButtonOpenFileHandler implements ActionListener{
		private JButton TempButton;
		private File file = null;		
		private JFileChooser fileChooserTemp;
		private mainFrame mFrame;
		
		/**
		 * 
		 * @param _startGeneratorButton to enable the button when a file is selected
		 */
		public ButtonOpenFileHandler(JButton _EnableButton, JFileChooser _fileChooser, mainFrame _mFrame ) {
			this.TempButton = _EnableButton;
			this.fileChooserTemp = _fileChooser;
			this.mFrame = _mFrame;
		}
		
		public void actionPerformed(ActionEvent e){

			//Next lines required for the File open Dialogue 
			fileChooserTemp.setFileSelectionMode(JFileChooser.FILES_ONLY); 
			fileChooserTemp.setAcceptAllFileFilterUsed(false);
			FileNameExtensionFilter filter = new FileNameExtensionFilter("uml","UML"); // show only files with extension *.UML
			fileChooserTemp.setFileFilter(filter); 			
			
				int returnVal = fileChooserTemp.showDialog(TempButton,"Choose XMI-Model file");
	
		        if (returnVal == JFileChooser.APPROVE_OPTION) {
		            file = fileChooserTemp.getSelectedFile();
		            System.out.println("Opening UML model file: " + file.getName() + "\n");
					
		            mFrame.setModelFileSet(true);	// set flag 
		            
					if(mFrame.getOutputDirSet()){
						this.TempButton.setEnabled(true);	// set generator button active 
					}
		           
		        } else {
		        	System.out.println("Open command cancelled by user! ");
		        }
		}

		public void setFile(File _file) {
			this.file = _file;
		}

		public File getFile() {
			return this.file;
		}
	}

	class ButtonStartGeneratorHandler implements ActionListener{
		private ButtonOpenFileHandler bofh;
		private ButtonOutputDirBtnHandler bodh;
		
		public ButtonStartGeneratorHandler(){
			
		}
		
		public ButtonStartGeneratorHandler(ButtonOpenFileHandler _bofh, ButtonOutputDirBtnHandler _bodh) {
			this.bofh = _bofh;
			this.bodh = _bodh;
		}
		
		public void actionPerformed(ActionEvent e){
	//		System.out.println("Starting generation with file: ");
			System.out.println("Starting generation...");
	//		System.out.println(this.bofh.getFile().getAbsolutePath());
		
			//Start OAW generator 
			GeneratorRunner g = new GeneratorRunner();
			g.run(null, null);
	//		g.run(this.bofh.getFile().getAbsolutePath().toString(), bodh.getSavePath());
		}
	}
	

	class ButtonOutputDirBtnHandler implements ActionListener{
		private JButton refButton,refButton2;
		private JFileChooser fileChooserTemp;
		private String savePath;
		private mainFrame mFrame;
		
		public  ButtonOutputDirBtnHandler(JButton _startGeneratorButton,JButton _startSimulationButton, JFileChooser _fileChooser,  mainFrame _mFrame ) {
			this.refButton = _startGeneratorButton;	
			this.refButton2 = _startSimulationButton;	
			this.fileChooserTemp = _fileChooser;
			this.mFrame = _mFrame;
		}
		
		public void actionPerformed(ActionEvent e){
			fileChooserTemp.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY); // use same file dialog but only for directory
						
			fileChooserTemp.setAcceptAllFileFilterUsed(false);    // disable the "All files" option
			fileChooserTemp.removeChoosableFileFilter(null);
			fileChooserTemp.resetChoosableFileFilters();
			
			int returnVal = fileChooserTemp.showDialog(refButton,"Choose target directory");
			
	        if (returnVal == JFileChooser.APPROVE_OPTION) {      	  
	        	savePath = fileChooserTemp.getSelectedFile().toString();  // save path == chosen file
	            System.out.println("target path for generation set to : " + savePath);     
	            
	            mFrame.setOutputDirSet(true);	// set flag 
	            
				if(mFrame.getModelFileSet()){
					this.refButton.setEnabled(true);	// set generator button active 
				}
	          
	         // set simulator button active 
	            this.refButton2.setEnabled(true);
				
	        } else {
	        	System.out.println("No output directory set by user! ");
	        	// set generator and simulator inactive 
				this.refButton.setEnabled(false);
				this.refButton2.setEnabled(false);
	        }
		}
		
		public String getSavePath() {
			return this.savePath;
		}
	}

	/**
	 * Class for the Simulation window
	 * @author frank.schumacher
	 *
	 */
	class sideFrame extends JFrame{
		
		private static final long serialVersionUID = 1L;
		sideFrame(String _name){
							
			super(_name);
			this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			this.setSize(700, 100);	//size of the JFrame in Horizontal * Vertical Pixels
		}
	}
	
	class simButton extends JButton{
		private String ModFilePath;
		private String ModFileName;
		private static final long serialVersionUID = 1L;
		
		simButton(String _name){	
			super(_name);
		}
		
		public void setModFilePath(String _ModFilePath)
		{
			ModFilePath = _ModFilePath;
		}
		
		public String getModFilePath()
		{
			return ModFilePath;
		}
		
		public void setModFileName(String _ModFileName)
		{
			ModFileName = _ModFileName;
		}
		
		public String getModFileName()
		{
			return ModFileName;
		}
	}
	
	class ButtonStartSimulationHandler implements ActionListener{
		private ButtonOutputDirBtnHandler bodh;
		private ButtonSimulationGeneratorHandler bsdh = new ButtonSimulationGeneratorHandler() ; // the  button handler for all simulation buttons
		
		public ButtonStartSimulationHandler( ButtonOutputDirBtnHandler _bodh) {
			this.bodh = _bodh;
		}
		
		/**
		 * The Action to perform when the "Start Simulation" Button is pressed
		 */
		public void actionPerformed(ActionEvent e){
			String DoFilePathList [];
			
		    String FilterList[] = {"**/*.do"};
		    DirectoryScanner DirScan = new DirectoryScanner();
			DirScan.setBasedir(bodh.getSavePath());  // set base dir for search of simulation files
			DirScan.setIncludes(FilterList);
			DirScan.scan();
			DoFilePathList= DirScan.getIncludedFiles();
			
			StringArray DoFileNameList = new StringArray();
			
			sideFrame simFrame = new sideFrame("ModelSim Control");
			Container content = simFrame.getContentPane();		//Get the "main drawing area"
			JPanel SimPanel = new JPanel(new GridLayout(1,1,5,5));
		 	
			if (DoFilePathList.length > 0)
			{
				System.out.println("the following state machines can be simulated : ");
				for(int i = 0; i < DoFilePathList.length; i++){
			    	
			    	DoFileNameList.add(DoFilePathList[i].split(Pattern.quote( "\\" ))			// extract file name 
			    			[DoFilePathList[i].split(Pattern.quote( "\\" )).length-1]);
			    	
			    	DoFilePathList[i]=bodh.getSavePath()+ "\\" + DoFilePathList[i].replaceAll(DoFileNameList.getArray()[i],""); // extract path name without file name
			    	
			    	System.out.println(DoFileNameList.getArray()[i]);
			    	simButton newSimButtonPtr = new simButton(DoFileNameList.getArray()[i].replaceAll("ModSim.do", ""));
			    	newSimButtonPtr.setModFilePath( DoFilePathList[i]);
			    	newSimButtonPtr.setModFileName( DoFileNameList.getArray()[i]);
			    	newSimButtonPtr.addActionListener(bsdh); 	// add the same handler for all buttons
			    	SimPanel.add(newSimButtonPtr); 				// add new simulation button to panel
			    }
				content.setLayout(new BorderLayout());
				content.add(SimPanel, BorderLayout.NORTH);	//Panel at top of Frame	
				simFrame.setVisible(true);	//Enable the JFrame
			}
			else{
				System.out.println("no simulation models were found!");
			}
		}
	}
	
	class ButtonSimulationGeneratorHandler implements ActionListener{
		
		public ButtonSimulationGeneratorHandler() {}
		
		public void actionPerformed(ActionEvent e){
			simButton tempBut = (simButton) e.getSource();
			System.out.println("-> Start ModelSim at path: " + tempBut.getModFilePath()+" \n with model script: "+ tempBut.getModFileName() );

			try {
	            String sTmp = "cmd /c CHDIR "+ tempBut.getModFilePath() +" & start ModelSim.exe -do "+ tempBut.getModFileName();
				System.out.println(sTmp);	//Output for Debug
				Runtime.getRuntime().exec(sTmp);	//Execute command
		    } catch (IOException exc) {      
		    	exc.printStackTrace();
	        }     
		}
	}
	
	/**
	 * Handles the Event when Button End is pressed
	 * @author frank.schumacher
	 *
	 */
	class ButtonEndHandler implements ActionListener{
		private JFrame jf;
		
		public ButtonEndHandler(JFrame _jf) {
			this.jf = _jf;
		}
		
		public void actionPerformed(ActionEvent e){
			this.jf.dispose();	//Close Mainframe	
		}
	}

//EOF
